(define (domain logistics)

    (:requirements
        :typing
    )

    (:types
        location - object 
        package vehicle - entity
        airplane truck - vehicle
    )

    (:predicates
        (at ?o - entity ?l - location)
        (in ?p - package ?v - vehicle)
        (road ?l1 - location ?l2 - location)
        (corridor ?l1 - location ?l2 - location)
        (empty ?v - vehicle)
    )

    (:action load
        :parameters (?p - package ?l - location ?v - vehicle)
        :precondition (and 
            (at ?p ?l)
            (at ?v ?l)
            (empty ?v)
        )
        :effect (and 
            (not (at ?p ?l))
            (in ?p ?v)
            (not (empty ?v))
        )
    )
    
    (:action unload
        :parameters (?p - package ?l - location ?v - vehicle)
        :precondition (and 
            (in ?p ?v)
            (at ?v ?l)
            (not (empty ?v))
        )
        :effect (and
            (not (in ?p ?v))
            (empty ?v)
            (at ?p ?l)
        )
    )
    
    (:action drive
        :parameters (?v - truck ?l1 - location ?l2 - location)
        :precondition (and 
            (at ?v ?l1)
            (road ?l1 ?l2)
        )
        :effect (and
            (not (at ?v ?l1))
            (at ?v ?l2)
        )
    )
    
    (:action fly
        :parameters (?v - airplane ?l1 - location ?l2 - location)
        :precondition (and 
            (at ?v ?l1)
            (corridor ?l1 ?l2)
        )
        :effect (and
            (not (at ?v ?l1))
            (at ?v ?l2)
        )
    )
)